"use strict";
'use client';
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const navigation_js_1 = require("next/navigation.js");
const store_js_1 = require("../../store.js");
const react_1 = __importStar(require("react"));
const shallow_1 = require("zustand/shallow");
const utils_js_1 = require("../../utils.js");
const GeschichteForNextAppRouter = ({ children, navigateDefaultOptions = { scroll: false }, }) => {
    const searchParams = (0, navigation_js_1.useSearchParams)();
    const { push, replace } = (0, navigation_js_1.useRouter)();
    const pathname = (0, navigation_js_1.usePathname)();
    const router = (0, react_1.useRef)({ push, replace, searchParams, pathname });
    const historyInstance = (0, react_1.useMemo)(() => {
        const { searchParams, push, replace, pathname } = router.current;
        return {
            initialSearch: () => searchParams,
            push: async (query, options) => {
                push(`${pathname}${(0, utils_js_1.createSearch)(query)}`, {
                    ...navigateDefaultOptions,
                    ...options,
                });
            },
            replace: async (query, options) => {
                replace(`${pathname}${(0, utils_js_1.createSearch)(query)}`, {
                    ...navigateDefaultOptions,
                    ...options,
                });
            },
        };
    }, [navigateDefaultOptions]);
    const useStore = (0, react_1.useMemo)(() => (0, store_js_1.createGeschichte)(historyInstance), [historyInstance]);
    const state = useStore(({ unregister, updateFromQuery }) => ({
        unregister,
        updateFromQuery,
    }), shallow_1.shallow);
    (0, react_1.useEffect)(() => {
        if (router.current.searchParams !== searchParams) {
            state.updateFromQuery(searchParams);
        }
        router.current = { push, replace, searchParams, pathname };
    }, [push, replace, pathname, searchParams, state]);
    (0, react_1.useEffect)(() => {
        const { unregister } = state;
        return () => {
            return unregister();
        };
    }, [state]);
    return (react_1.default.createElement(store_js_1.StoreContext.Provider, { value: useStore }, children));
};
exports.default = (0, react_1.memo)(GeschichteForNextAppRouter);
